import java.util.*;

class VettoreOrdinato<E extends Comparable<E>> {
   private Comparable<?> vettore[];
   private int curDim;  //dimensione effettiva

public VettoreOrdinato (int initDim) {
	vettore = new Comparable<?>[initDim];
	curDim = 0;
   }

public VettoreOrdinato () {
	this(1);
 }


public boolean aggiungi (E elemento) {
	//NB: l'inserimento non preserva l'eventuale ordinamento
  if (elemento == null) return false;
  if (curDim == vettore.length) {
	//Incrementiamo se necessario le dimensione dell'array del doppio 
	//static <T> T[] copyOf(T[] original, int newLength)
	//Copies the specified array, truncating or padding with nulls (if necessary) so the copy has the specified length.
  	vettore = Arrays.copyOf(vettore, vettore.length * 2);
  	
  	//Comparable<?>[] newVettore = new Comparable<?>[vettore.length * 2];
  	//System.arraycopy(vettore, 0, newVettore, 0, vettore.length);
  	//vettore = newVettore;
  }
	vettore[curDim++] = elemento;
  return true;
}


//NB: l'eliminazione non preserva l'eventuale ordinamento
public E elimina (int indice) {
  if (indice >= 0 && indice < curDim) {
  	Comparable<?> obj = vettore[indice];
  	vettore[indice] = vettore[--curDim];
  	if (curDim <= vettore.length/4)
  		// ridimensiona
  		vettore = Arrays.copyOf(vettore, vettore.length/2);
	    return (E)obj;
  }
	else return null;
}

public E elimina () {
	return elimina(curDim-1);
}

 public E leggi (int indice) {
    if (indice >= 0 && indice < curDim)
	   return (E)vettore[indice];
	else return null;
 }
 
 public int dim () { return curDim; }
 
 public int length () { return vettore.length; }
 

//sort(Object[] a, int fromIndex, int toIndex)
//Sorts the specified range of the specified array of objects into ascending order,
//according to the natural ordering of its elements.
 public void ordina () {
	 //NB: toIndex  il numero di items da ordinare
	 Arrays.sort(vettore, 0, curDim);
 }
 
 
 public void stampa () {
	    System.out.print("[ ");
	    for (int i = 0; i < curDim; i++){
	  	  E x = this.leggi(i);
	  	  System.out.print(x + "; ");
	    }
	    System.out.println("]");
	}
 

}

